﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;

namespace STPP
{
    public class Vecna : PowerBase, Messages.IUseContinuous
    {
        public int Thrust = 8;
        //public bool CanUse = true;
        public AudioClip ding = ModAPI.LoadSound("People/Vecna/ding.wav");
        public AudioClip break1 = ModAPI.LoadSound("People/Vecna/break1.wav");
        public AudioClip pop = ModAPI.LoadSound("People/Vecna/pop.wav");
        AudioSource auds;


        public override void Start()
        {
            //We set our power activation type (Head,Chest,Hand)
            Activation = "Hand";

            //Always keep this
            DisablesGrips = false;
            base.Start();
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = Global.main.SoundEffects;
            auds.volume = 1;
        }

        private IEnumerator FlyAwayMyBelovedHuman(GameObject head)
        {
            foreach (var Limbs in head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
            {
                for (int i = 0; i < Thrust; i++)
                {
                    Limbs.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(0f, 7f);
                    yield return new WaitForSeconds(0.05f);
                }
            }
        }

        private IEnumerator diediedie(GameObject head)
        {
            yield return new WaitForSeconds(3f);
            var huhahua = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2];
            var arm1 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11];
            var arm2 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[10];
            arm1.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            arm2.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            auds.PlayOneShot(break1);
            arm1.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(7f, 7f);
            arm2.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(-7f, 7f);
            yield return new WaitForSeconds(1f);
            huhahua.gameObject.AddComponent<FreezeBehaviour>();
            var arm3 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[12];
            var arm4 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13];
            arm3.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            arm4.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            auds.PlayOneShot(break1);
            arm3.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(7f, 7f);
            arm4.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(-7f, 7f);
            yield return new WaitForSeconds(1f);

            var leg1 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[4];
            var leg2 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[5];
            leg1.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            leg2.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            auds.PlayOneShot(break1);
            leg1.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(7f, 7f);
            leg2.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(-7f, 7f);
            yield return new WaitForSeconds(1f);
            var leg3 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[7];
            var leg4 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[8];
            leg3.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            leg4.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            auds.PlayOneShot(break1);
            leg3.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(7f, 7f);
            leg4.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(-7f, 7f);
            yield return new WaitForSeconds(1f);
            var head2 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0];
            yield return new WaitForSeconds(1f);
            ModAPI.CreateParticleEffect("BloodExplosion", head.transform.position);
            head2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
            auds.PlayOneShot(pop);
            foreach (var Limbs in head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
            {
                var huhas = Limbs.gameObject.GetComponent<FreezeBehaviour>();
                Destroy(huhas);
                Limbs.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(0f, 7f);
            }
         //   CanUse = true;
            head = null;
        }

        //This is the actual power part of your power, this function will trigger when the activation limb is used.
        public override void UsePower()
        {
            //This if statement exists to check if your power is selected and enabled in the power menu
            if (Enabled)
            {
               // if (CanUse)
                {
                    var cast = Physics2D.CircleCast(this.transform.position, ModAPI.PixelSize * 3f, -this.transform.up, 15f, LayerMask.GetMask("Objects")); //we use circle cast because being slightly off would be annoying.
                    if (cast.transform != null && cast.transform.root != this.transform.root)
                    {
                        if (cast.transform.gameObject.GetComponent<LimbBehaviour>() && cast.transform.gameObject.GetComponent<LimbBehaviour>().HasBrain && !cast.transform.gameObject.GetComponent<Vecnaed>())
                        {
                            var head = cast.transform.gameObject;
                            head.AddComponent<Vecnaed>().break1 = break1;
                            head.GetComponent<Vecnaed>().ding = ding;
                            head.GetComponent<Vecnaed>().pop = pop;
                            head.GetComponent<Vecnaed>().Thrust = Thrust;
                            StartCoroutine(FlyAwayMyBelovedHuman(head));
                            StartCoroutine(head.GetComponent<Vecnaed>().diediedie(head));
                            auds.PlayOneShot(ding);
                          //  this.CanUse = false;
                        }
                    }
                }
            }
        }

        public void UseContinuous(ActivationPropagation prop)
        {

        }

        /// <summary>
        /// Set up the power on a character.
        /// </summary>
        /// <param name="body">The selected limb of the user.</param>
        /// <param name="person">The PersonBehaviour of the user. (body.Person)</param>
        /// <param name="Instance">The overall instance of the user. ( body.Person.gameObject)</param>
        public static void SetUpPower(LimbBehaviour body, PersonBehaviour person, Sprite powerIcon = null, string powerName = "Vecna")
        {
            //This checks if the person already has the power, if they don't we give it to them (duplicates are bad) NOTE:make sure to change the class to your new power class
            if (!body.GetComponent<Vecna>() || body.GetComponent<Vecna>().PowerName != powerName)
            {
                //Adds your new power to the person NOTE:make sure to change the class to your new power class
                var Power = body.gameObject.AddComponent<Vecna>();

                //This sets the power's icon, make sure you add the your new icon to the ResourceStorage NOTE:make sure to change the class to your new power class
                if (powerIcon == null)
                {
                    Power.PowerIcon = STPP.IconVecna;
                }
                else
                {
                    Power.PowerIcon = powerIcon;
                }

                Power.PowerName = powerName;

                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    //This triggers your power NOTE:make sure to change the class to your new power class
                    Power.UsePower();
                };
            }
        }
    }
    public class Vecnaed : MonoBehaviour
    {
        AudioSource auds;
        public int Thrust = 8;
        //public bool CanUse = true;
        public AudioClip ding;
        public AudioClip break1;
        public AudioClip pop;
        public void Start()
        {
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            Global.main.AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = Global.main.SoundEffects;
            auds.volume = 1;
        }
        
        public IEnumerator diediedie(GameObject head)
        {
            yield return new WaitForSeconds(3f);
            var huhahua = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2];
            var arm1 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11];
            var arm2 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[10];
            arm1.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            arm2.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            auds.PlayOneShot(break1);
            arm1.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(7f, 7f);
            arm2.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(-7f, 7f);
            yield return new WaitForSeconds(1f);
            huhahua.gameObject.AddComponent<FreezeBehaviour>();
            var arm3 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[12];
            var arm4 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13];
            arm3.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            arm4.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            auds.PlayOneShot(break1);
            arm3.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(7f, 7f);
            arm4.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(-7f, 7f);
            yield return new WaitForSeconds(1f);

            var leg1 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[4];
            var leg2 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[5];
            leg1.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            leg2.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            auds.PlayOneShot(break1);
            leg1.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(7f, 7f);
            leg2.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(-7f, 7f);
            yield return new WaitForSeconds(1f);
            var leg3 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[7];
            var leg4 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[8];
            leg3.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            leg4.gameObject.GetComponent<LimbBehaviour>().Broken = true;
            auds.PlayOneShot(break1);
            leg3.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(7f, 7f);
            leg4.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(-7f, 7f);
            yield return new WaitForSeconds(1f);
            var head2 = head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0];
            yield return new WaitForSeconds(1f);
            ModAPI.CreateParticleEffect("BloodExplosion", head.transform.position);
            head2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
            auds.PlayOneShot(pop);
            foreach (var Limbs in head.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
            {
                var huhas = Limbs.gameObject.GetComponent<FreezeBehaviour>();
                Destroy(huhas);
                Limbs.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(0f, 7f);
            }
            //   CanUse = true;
            head = null;
        }
    }
}