using System.Collections;
using System;
using UnityEngine;
using System.Linq;
using System.Collections.Generic;
using Random = UnityEngine.Random;
using UnityEngine.Events;
using TMPro;
using UnityEngine.UI;
using System.Reflection;

namespace STPP
{
    public class STPP
    {

        public static Sprite IconVecna = ModAPI.LoadSprite("Power Icons/Vecna.png");
        public static Sprite IconTelekinesis = ModAPI.LoadSprite("Power Icons/Eleven.png");
        public static Sprite dustinhat = ModAPI.LoadSprite("People/Dustin/dustin_hat.png");

        public static string ModTag = "<color=#ca161b>STPP <color=white>";

        public static void Main()
        {
            CategoryBuilder.Create("Stranger Things Power Pack", "A compilation of Stranger Things Characters and a working upside down by Team Wilson/Billson.", ModAPI.LoadSprite("logo_category.png"));

            UpsidedownPortal.Enabled = false;
            UpsidedownPortal.DoingAnim = false;

            ModAPI.OnItemSpawned += (sender, obj) =>
            {
                GameObject gameobject = obj.Instance;
                if (UpsidedownPortal.Enabled)
                {
                    gameobject.transform.root.gameObject.AddComponent<ExistOnlyInUpsideDown>();
                }
            };

            ModAPI.RegisterLiquid("DEMOHEAL", new DemoHeal());

            //Portal
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
                    NameOverride = ModTag + "Gate",
                    DescriptionOverride = "An open wound in space and time. Any entity touching the gate will be transported to the Upside Down. Activating the gate will bring the camera to the Upside Down and back.\n-press F to traverse into the upside down.\n-Reset the upside down in context menu.",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("Upside Down/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Upside Down/portal.png");
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                        Instance.AddComponent<UpsidedownPortal>();
                        GameObject glo = new GameObject("glo");
                        glo.transform.SetParent(Instance.transform);
                        glo.transform.localPosition = new Vector3(0f, 0f);
                        glo.transform.localScale = new Vector3(1f, 1f);
                        var glosprite = glo.AddComponent<SpriteRenderer>();
                        glosprite.sprite = ModAPI.LoadSprite("Upside Down/glo.png");
                        glosprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        glosprite.transform.position = Instance.transform.position;
                        glosprite.transform.rotation = Instance.transform.rotation;
                        glosprite.sortingLayerName = "Top";
                        glosprite.color = Color.white;
                        glo.gameObject.AddComponent<pulsate>();
                        Instance.AddComponent<AudioSource>().spatialBlend = 1;
                        Instance.GetComponent<AudioSource>().clip = ModAPI.LoadSound("Upside Down/amb.wav");
                        Instance.AddComponent<FreezeBehaviour>();
                        Instance.GetComponent<AudioSource>().loop = true;
                    }
                }
            );

                    //Wilson
                    ModAPI.Register(
            new Modification()
    {

        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = ModTag + "Scoops Ahoy Wilson",
        DescriptionOverride = "From mad science to serving ice cream",
        CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
        ThumbnailOverride = ModAPI.LoadSprite("People/Wilson/thumb.png"),
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("People/Wilson/Wilson.png");
            var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
            var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

            var person = Instance.GetComponent<PersonBehaviour>();

            person.SetBodyTextures(skin, flesh, bone, 1);

            person.Limbs[0].gameObject.AddComponent<RogVoice>();


            person.BoneBreakClips = new AudioClip[]
            {
                ModAPI.LoadSound("People/Wilson/rogbrok.wav"),
                ModAPI.LoadSound("People/Wilson/roghurt.wav")
             };

        }
    }
            );

            //Steve
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Steve Harrington",
                    DescriptionOverride = "I may be a pretty shitty boyfriend, but turns out I’m actually a pretty damn good babysitter. - Steve Harrington\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Steve/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Steve/Steve_1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Steve/Steve_2.png"), "Steve's Season 2 Costume", "Steve's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Steve/steve_2_upside_down.png"), "Steve's Season 2 Upside Down Costume", "Steve's Season 2 Upside Down Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Steve/Steve_3.png"), "Steve's Season 3 Costume", "Steve's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Steve/Steve_4.png"), "Steve's Season 4 Costume", "Steve's Season 4 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Steve/Steve_season_4_upside_down.png"), "Steve's Season 4 Upside Down Costume", "Steve's Season 4 Upside Down Costume");
                    }
                }
            );

            //Johnathan
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Jonathan Byers",
                    DescriptionOverride = "Nobody normal ever accomplished anything meaningful in this world. - Jonathan Byers\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Jonathan/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Jonathan/johnathan_1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Jonathan/Johnathan_2.png"), "Jonathan's Season 2 Costume", "Jonathan's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Jonathan/Johnathan_3.png"), "Jonathan's Season 3 Costume", "Jonathan's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Jonathan/Johnathan_4.png"), "Jonathan's Season 4 Costume", "Jonathans Season 4 Costume");
                    }
                }
            );

            //Eleven
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Eleven",
                    DescriptionOverride = "Friends don't lie. - Eleven\n-Has multiple costumes, and has the power to move anything by pointing at it, and can also push and pull objects from herself by choosing the power in the power menu and activating her hands",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Eleven/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Eleven/Eleven1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Eleven/Eleven.png"), "Eleven's Hospital Gown Costume", "Eleven's Hospital Gown Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Eleven/Eleven1_Wig.png"), "Eleven's Wig Costume", "Eleven's Wig Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Eleven/Eleven_2.png"), "Eleven's Season 2 Costume", "Eleven's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Eleven/Eleven_Emokid3.png"), "Eleven's Punk Costume", "Eleven's Punk Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Eleven/Eleven_S3.png"), "Eleven's Season 3 Costume", "Eleven's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Eleven/Eleven_S4.png"), "Eleven's Season 4 Costume", "Eleven's Season 4 Costume");

                        Telekinesis.SetUpPower(person.Limbs[11], person, IconTelekinesis, "Push", 50);
                        Telekinesis.SetUpPower(person.Limbs[13], person, IconTelekinesis, "Push", 50);
                        Telekinesis.SetUpPower(person.Limbs[11], person, IconTelekinesis, "Pull", -50);
                        Telekinesis.SetUpPower(person.Limbs[13], person, IconTelekinesis, "Pull", -50);
                        Control.SetUpPower(person.Limbs[11], person, IconTelekinesis);
                        Control.SetUpPower(person.Limbs[13], person, IconTelekinesis);
                    }
                }
            );

            //Eddie
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Eddie Munson",
                    DescriptionOverride = "We're the freaks because we like to play a fantasy game. - Eddie Munson\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Eddie/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Eddie/Eddie.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Eddie/upsidedown.png"), "Eddie's Upside Down Costume", "Eddie's Upside Down Costume");
                    }
                }
            );

            //Bob
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Bob Newby",
                    DescriptionOverride = "I always thought stuff like this happened in movies and comic books, certainly not in Hawkins and certainly not to someone like you. - Bob Newby",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Bob/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Bob/Bob.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Alexei
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Dr. Alexei",
                    DescriptionOverride = "Tell that stupid man it is not the same in the slightest, and I would like the cherry I requested. - Dr. Alexei",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Alexei/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Alexei/Dr._Alexei.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Jason
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Jason Carver",
                    DescriptionOverride = "You want something freak? - Jason Carver",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Jason/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Jason/Jason.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Fred
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Fred Benson",
                    DescriptionOverride = "Our children don’t live here anymore. You didn’t know that? - Fred Benson",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Fred/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Fred/Fred.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Hopper
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Jim Hopper",
                    DescriptionOverride = "C-O-M-promise. Compromise. How about that's your word for the day? Yeah? It's something that's kinda in-between. It's like halfway happy. - Jim Hopper\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Hopper/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Hopper/hopper1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Hopper/hopper2.png"), "Hopper's Season 2 Costume", "Hopper's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Hopper/hopper3.png"), "Hopper's Season 3 Costume", "Hopper's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Hopper/hopper4.png"), "Hopper's Season 4 Costume", "Hopper's Season 4 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Hopper/hopper_eleven_skin.png"), "Hopper's Eleven Costume", "Hopper's Eleven Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Hopper/hopper_prison.png"), "Hopper's prison Costume", "Hopper's prison Costume");
                    }
                }
            );

            //Suzie
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Suzie Bingham",
                    DescriptionOverride = "I haven't heard from you in a week, and now you want a mathematical equation that you should know so you can save the world? - Suzie Bingham\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Suzie/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Suzie/suzie.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Suzie/suzie_s3.png"), "Suzie's Season 3 Costume", "Suzie's Season 3 Costume");
                    }
                }
            );

            //Erica
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Erica Sinclair",
                    DescriptionOverride = "Just the facts. - Erica Sinclair\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Erica/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Erica/Erica_S1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Erica/Erica_S4.png"), "Erica's Season 4 Costume", "Erica's Season 4 Costume");
                    }
                }
            );

            //Patrick
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Patrick McKinney",
                    DescriptionOverride = "I think I'm cursed - Patrick McKinney\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Patrick/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Patrick/patrick.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Patrick/Patrick_alt_outfit.png"), "Patrick's Jacketless Costume", "Patrick's Jacketless Costume");
                    }
                }
            );

            //Ted
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Ted Wheeler",
                    DescriptionOverride = "What happened to her hair? Oh my god - is she Russian? - Ted Wheeler",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Ted/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Ted/Ted.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Yuri
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Yuri",
                    DescriptionOverride = "My mother is dead.. tired of living like a bum! - Yuri",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Yuri/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Yuri/Yuri.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Enzo
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Enzo",
                    DescriptionOverride = "Your friend is stuck.You get me money, I make him unstuck. - Enzo",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Enzo/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Enzo/Enzo.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Billy
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Billy Hargrove",
                    DescriptionOverride = "Don't take it too hard man, pretty boy like you doesn't have anything to worry about. Plenty of bitches in the sea. - Billy Hargrove\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Billy/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Billy/Billy1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Billy/Billy2.png"), "Billy's Season 2 Costume", "Billy's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Billy/billy3.png"), "Billy's Season 3 Costume", "Billy's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Billy/Dead_bill.png"), "Vecna's Billy", "Vecna's Billy");
                    }
                }
            );

            //Dustin
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Dustin Henderson",
                    DescriptionOverride = "When I become rich and famous for this one day, don't come crawling back, saying, oh, my God, Dustin, I'm so sorry for being mean to you back in 8th grade. - Dustin Henderson\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Dustin/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Dustin/dustin2hat.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");
                        var head = Instance.transform.Find("Head");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin_1.png"), "Dustin's Season 1 hatless Costume", "Dustin's Season 1 hatless Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin.png"), "Dustin's Season 2 Costume", "Dustin's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin2.png"), "Dustin's Season 2 hatless Costume", "Dustin's Season 2 hatless Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin3.png"), "Dustin's Season 3 Costume", "Dustin's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin_3.png"), "Dustin's Season 3 hatless Costume", "Dustin's Season 3 hatless Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin4hat.png"), "Dustin's Season 4 Costume", "Dustin's Season 4 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin4.png"), "Dustin's Season 4 hatless Costume", "Dustin's Season 4 hatless Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustinupsidedown.png"), "Dustin's Season 4 Upside Down Costume", "Dustin's Season 4 Upside Down Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin_GB.png"), "Dustin's Ghostbuster Costume", "Dustin's Ghostbuster Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Dustin/dustin_hellfire.png"), "Dustin's Hellfire Costume", "Dustin's Hellfire Costume");
                        PPF.PowerPackFrameworkFunctions.AddCustomizedLimbToSkin(person, 0, "Default", ModAPI.LoadSprite("People/dustin/dustinhat1.png", 10), ModAPI.LoadTexture("People/Nancy/Head Flesh.png"), ModAPI.LoadTexture("People/Nancy/Head Bone.png"));
                        PPF.PowerPackFrameworkFunctions.AddCustomizedLimbToSkin(person, 0, "Dustin's Season 2 Costume", ModAPI.LoadSprite("People/dustin/dustinhat1.png", 10), ModAPI.LoadTexture("People/Nancy/Head Flesh.png"), ModAPI.LoadTexture("People/Nancy/Head Bone.png"));
                        PPF.PowerPackFrameworkFunctions.AddCustomizedLimbToSkin(person, 0, "Dustin's Season 3 Costume", ModAPI.LoadSprite("People/dustin/dustinhat3.png", 10), ModAPI.LoadTexture("People/Nancy/Head Flesh.png"), ModAPI.LoadTexture("People/Nancy/Head Bone.png"));
                        PPF.PowerPackFrameworkFunctions.AddCustomizedLimbToSkin(person, 0, "Dustin's Season 4 Costume", ModAPI.LoadSprite("People/dustin/dustinhat4.png", 10), ModAPI.LoadTexture("People/Nancy/Head Flesh.png"), ModAPI.LoadTexture("People/Nancy/Head Bone.png"));
                    }
                }
            );

            //Murray
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Murray Bauman",
                    DescriptionOverride = "I'm not exactly an expert in parenting. But for what little it's worth, I think you did the right thing. The responsible thing. Your children, bless their mischievous souls, they like to get involved. - Murray Bauman\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Murray/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Murray/murray_shirt.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Murray/murray_shirtless.png"), "Shirtless Murray", "Shirtless Murray");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Murray/murray_yuri.png"), "Murray Yuri disquise", "Murray Yuri disquise");
                    }
                }
            );

            //Argyle
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Argyle",
                    DescriptionOverride = "Open our minds?! There's an open grave in front of me, man!!  - Argyle",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Argyle/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Argyle/Argyle.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Joyce
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Joyce Byers",
                    DescriptionOverride = "Maybe I am a mess. Maybe I’m crazy. Maybe I’m out of my mind! But, God help me, I will keep these lights up until the day I die if I think there’s a chance that Will’s still out there! - Joyce Byers",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Joyce/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Joyce/joyce1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Chrissy
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Chrissy Cunningham",
                    DescriptionOverride = "Bone snap - Chrissy Cunningham",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Chrissy/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Chrissy/chrissy.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");
                        var head = Instance.transform.Find("Head");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                                                person.Limbs[0].gameObject.AddComponent<CustomBodyPart>().OgSkin = person.Limbs[0].GetComponent<SpriteRenderer>().sprite;
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgFlesh = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_FleshTex");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().OgBone = (Texture2D)person.Limbs[0].GetComponent<SpriteRenderer>().material.GetTexture("_BoneTex");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewSkin = ModAPI.LoadSprite("People/Chrissy/Head.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewFlesh = ModAPI.LoadTexture("People/Chrissy/Head Flesh.png");
                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().NewBone = ModAPI.LoadTexture("People/Chrissy/Head Bone.png");

                        person.Limbs[0].gameObject.GetComponent<CustomBodyPart>().SetNewTextures();
                    }
                }
            );

            //Dr Owens
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Dr. Owens",
                    DescriptionOverride = "All living organisms develop defense mechanisms against attack. They adapt. They find some way to survive. - Dr. Owens",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Dr Owens/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Dr Owens/dr_owens.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            //Friendly Orderly
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Friendly Orderly",
                    DescriptionOverride = "You see, humans, are a unique type of pest. - Friendly Orderly",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Friendly Orderly/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Friendly Orderly/001.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        Telekinesis.SetUpPower(person.Limbs[11], person, IconTelekinesis, "Push", 50);
                        Telekinesis.SetUpPower(person.Limbs[13], person, IconTelekinesis, "Push", 50);
                        Telekinesis.SetUpPower(person.Limbs[11], person, IconTelekinesis, "Pull", -50);
                        Telekinesis.SetUpPower(person.Limbs[13], person, IconTelekinesis, "Pull", -50);
                        Control.SetUpPower(person.Limbs[11], person, IconTelekinesis);
                        Control.SetUpPower(person.Limbs[13], person, IconTelekinesis);
                    }
                }
            );

            //Victor
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Victor Creel",
                    DescriptionOverride = "Did I survive? No, I assure you, I am still very much in hell. - Victor Creel\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Victor/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Victor/Victor_Creel.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Victor/Victor.png"), "Young Victor Creel", "Young Victor Creel");
                    }
                }
            );

            //Will
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Will Byers",
                    DescriptionOverride = "It's like when you have a dream and you can't remember it unless you think really hard. - Will Byers\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Will/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Will/Will1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Will/Will_S2.png"), "Will's Season 2 Costume", "Will's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Will/Will_S3.png"), "Will's Season 3 Costume", "Will's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Will/Will_S4.png"), "Will's Season 4 Costume", "Will's Season 4 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Will/Will_GB.png"), "Will's Ghostbuster Costume", "Will's Ghostbuster Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Will/WillDD.png"), "Will's D&D Costume", "Will's D&D Costume");
                        PPF.PowerPackFrameworkFunctions.AddCustomizedLimbToSkin(person, 0, "Will's D&D Costume", ModAPI.LoadSprite("People/will/head.png", 10), ModAPI.LoadTexture("People/Nancy/Head Flesh.png"), ModAPI.LoadTexture("People/Nancy/Head Bone.png"));
                    }
                }
            );

            //Nancy
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Nancy Wheeler",
                    DescriptionOverride = "All this time, I’ve been trying so hard to pretend like everything is fine, but it’s not. - Nancy Wheeler\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Nancy/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Nancy/Nancy_S1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Nancy/Nancy_S2.png"), "Nancy's Season 2 Costume", "Nancy's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Nancy/Nancy_S3.png"), "Nancy's Season 3 Costume", "Nancy's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Nancy/Nancy_S4.png"), "Nancy's Season 4 Costume", "Nancy's Season 4 Costume");
                        PPF.PowerPackFrameworkFunctions.AddCustomizedLimbToSkin(person, 0, "Default", ModAPI.LoadSprite("People/Nancy/Head Skin.png",9), ModAPI.LoadTexture("People/Nancy/Head Flesh.png"), ModAPI.LoadTexture("People/Nancy/Head Bone.png"));
                    }
                }
            );

            //Karen
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Karen Wheeler",
                    DescriptionOverride = "People are always saying you can’t. That you shouldn’t. That you’re not smart enough, not good enough. This world, it beats you up again and again until eventually… Most people, they just stop trying. But you’re not like that. You’re a fighter. You always have been. - Nancy Wheeler\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Karen/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Karen/Karen_s1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Karen/Karen_wheeler_s3.png"), "Karen's Season 3 Costume", "Karen's Season 3 Costume");
                    }
                }
            );

            //Martin Brenner
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Martin Brenner",
                    DescriptionOverride = "It's reaching out to you because it wants you - it's calling you, so don't turn away from it this time.... - Martin Brenner\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Dr Brenner/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Dr brenner/Dr_brenner.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/dr brenner/dr_brenner_without_coat.png"), "dr brenner coatless costume", "dr brenner coatless costume");
                    }
                }
            );

            //Max
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Max Mayfield",
                    DescriptionOverride = "I'm just going to stop assuming that I know anything. - Max Mayfield\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Max/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Max/Max_s2.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Max/Max_s3.png"), "Max's Season 3 Costume", "Max's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Max/Max_s4.png"), "Max's Season 4 Costume", "Max's Season 4 Costume");
                        PPF.PowerPackFrameworkFunctions.AddCustomizedLimbToSkin(person, 0, "Max's Season 4 Costume", ModAPI.LoadSprite("People/Max/Max's head.png", 10), ModAPI.LoadTexture("People/Nancy/Head Flesh.png"), ModAPI.LoadTexture("People/Nancy/Head Bone.png"));
                    }
                }
            );

            //Steve's Bat
            ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),
                        NameOverride = ModTag + "Steve's Bat",
                        DescriptionOverride = "Best out of this world demon hitter of all time",
                        CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                        ThumbnailOverride = ModAPI.LoadSprite("People/Steve/Batthumb.png"),
                        AfterSpawn = (Instance) =>
                       {
                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("People/Steve/Bat.png");
                           GameObject Item3 = GameObject.Instantiate(ModAPI.FindSpawnable("Baseball Bat").Prefab);
                           CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("Baseball Bat"), Item3);
                           Item3.transform.SetParent(Instance.transform);
                           Item3.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("People/Steve/spikes.png");
                           Item3.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                           Item3.FixColliders();
                           Item3.transform.position = Instance.transform.position;
                           Item3.transform.eulerAngles = Instance.transform.eulerAngles;
                           Item3.gameObject.AddComponent<FixedJoint2D>();
                           Item3.gameObject.GetComponent<FixedJoint2D>().connectedBody = Instance.gameObject.GetComponent<Rigidbody2D>();
                           var Poop = Instance.AddComponent<NoCollide>();
                           Poop.NoCollideSetA = Item3.GetComponentsInChildren<Collider2D>();
                           Poop.NoCollideSetB = Instance.gameObject.GetComponentsInChildren<Collider2D>();
                           var phys = Item3.gameObject.GetComponent<PhysicalBehaviour>();
                           var prop = ModAPI.FindPhysicalProperties("Wood");
                           prop.Sharp = true;
                           prop.SharpAxes = new[]
                           {
                            new SharpAxis(Vector2.right, 0f, 0.1f, true, false),
                                                        new SharpAxis(Vector2.left, 0f, 0.1f, true, false),
                                                                                    new SharpAxis(Vector2.down, 0f, 0.1f, true, false),
                                                                                                                new SharpAxis(Vector2.up, 0f, 0.1f, true, false),
                    };
                           phys.Properties = prop;
                           Item3.AddComponent<AudioSourceTimeScaleBehaviour>();
                           Instance.FixColliders();
                       }
                    }
            );

            //Mike
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Mike Wheeler",
                    DescriptionOverride = "If anyone asks where I am, I've left the country! - Mike Wheeler\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Mike/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Mike/mike_s1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/Mike_s1_2.png"), "Mike's Season 1 Alternative Costume", "Mike's Season 1 Alternative Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/Mike_s2.png"), "Mike's Season 2 Costume", "Mike's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/mike_s2_2.png"), "Mike's Season 2 Alternative Costume", "Mike's Season 2 Alternative Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/dipshit.png"), "Mike's Season 2 Upside Down Costume", "Mike's Season 2 Upside Down Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/Mike_S3.png"), "Mike's Season 3 Costume", "Mike's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/Mike_S3_starcourt.png"), "Mike's Season 3 Starcourt Costume", "Mike's Season 3 Starcourt Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/Mike_S4.png"), "Mike's Season 4 Costume", "Mike's Season 4 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/Mike_S4_Hellfire.png"), "Mike's Hellfire Costume", "Mike's Hellfire Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Mike/Mike_ghostbusters.png"), "Mike's Ghostbuster Costume", "Mike's Ghostbuster Costume");
                    }
                }
            );

            //Lucas
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Lucas Sinclair",
                    DescriptionOverride = "First of all, it’s a wrist rocket. - Lucas Sinclair\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Lucas/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Lucas/lucas_1.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Lucas/Lucas_2.png"), "Lucas's Season 2 Costume", "Lucas's Season 2 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Lucas/lucas_3.png"), "Lucas's Season 3 Costume", "Lucas's Season 3 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Lucas/lucas_4.png"), "Lucas's Season 4 Costume", "Lucas's Season 4 Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Lucas/Lucas_GB.png"), "Lucas's Ghostbuster Costume", "Lucas's Ghostbuster Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Lucas/Lucas_with_jacket.png"), "Lucas's Basketball Costume", "Lucas's Basketball Costume");
                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Lucas/Lucas_hellfire.png"), "Lucas's Hellfire Costume", "Lucas's Hellfire Costume");
                    }
                }
            );

            //Robin
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Robin Buckley",
                    DescriptionOverride = "We all die, my strange little child friend. It’s just a matter of how and when. - Robin Buckley\n-Has multiple costumes",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Robin/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Robin/robin_3.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        PPF.PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("People/Robin/robin_4.png"), "Robin's Season 4 Costume", "Robin's Season 4 Costume");
                    }
                }
            );

            //Vecna
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Vecna",
                    DescriptionOverride = "It's time, for your suffering, to end. - Vecna\n-Point at someones head and activate his hands to send them flying up, break their bones and eventually pop their head",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Vecna/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/Vecna/Vecna.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4.5f;
                            body.Health *= 820f;
                            body.InitialHealth *= 80f;
                            body.ShotDamageMultiplier *= 0f;
                            body.BreakingThreshold += 111f;
                            body.Vitality *= 520f;
                            body.ImpactPainMultiplier *= 0.1f;
                            body.Numbness *= 1f;
                            body.CirculationBehaviour.BloodFlow *= 3000f;
                            body.IsLethalToBreak = false;
                            body.transform.root.localScale *= 1.02f;
                            body.GetComponent<LimbBehaviour>().RegenerationSpeed = 9999;
                            body.gameObject.AddComponent<regenstuffnthing>();
                            if (body.gameObject.name == "UpperArmFront")
                            {
                                OtherStuff.SetBodyPartTexture(body, ModAPI.LoadTexture("People/Vecna/Front_arm_vecna.png"), ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png"));
                            }
                            else if (body.gameObject.name == "LowerArmFront")
                            {
                                OtherStuff.SetBodyPartTexture(body, ModAPI.LoadTexture("People/Vecna/Front_arm_vecna.png"), ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png"));
                                var finger = new GameObject("finger");
                                finger.transform.SetParent(body.gameObject.transform);
                                finger.transform.localPosition = new Vector3(0f, 0f);
                                finger.transform.localScale = new Vector3(1f, 1f);
                                var fingerSprite = finger.AddComponent<SpriteRenderer>();
                                fingerSprite.sprite = ModAPI.LoadSprite("People/Vecna/fingywingy.png");
                                finger.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                        }
                        Telekinesis.SetUpPower(person.Limbs[11], person, IconTelekinesis, "Push", 50);
                        Telekinesis.SetUpPower(person.Limbs[13], person, IconTelekinesis, "Push", 50);
                        Telekinesis.SetUpPower(person.Limbs[11], person, IconTelekinesis, "Pull", -50);
                        Telekinesis.SetUpPower(person.Limbs[13], person, IconTelekinesis, "Pull", -50);
                        Control.SetUpPower(person.Limbs[11], person, IconTelekinesis);
                        Control.SetUpPower(person.Limbs[13], person, IconTelekinesis);
                        Vecna.SetUpPower(person.Limbs[11], person);
                        Vecna.SetUpPower(person.Limbs[13], person);
                    }
                }
            );

            //Demogorgon
            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Demogorgon",
                    DescriptionOverride = "Actual Aggressive noise\n-Press F on head to open mouth, and F again to bite down on someone.",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/demogorgon/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/demogorgon/Demogorgon main.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                    //    person.gameObject.AddComponent<eeee>();

                        person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("People/demogorgon/Head.png", 10f);
                        person.Limbs[0].gameObject.AddComponent<DemoScreamer>().NormalHead = ModAPI.LoadSprite("People/demogorgon/Head.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<DemoScreamer>().ScreamHead = ModAPI.LoadSprite("People/demogorgon/Head bad.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<DemoScreamer>().Wowsounds = new List<AudioClip>() { ModAPI.LoadSound("People/demogorgon/scream1.mp3"), ModAPI.LoadSound("People/demogorgon/scream1.mp3"), ModAPI.LoadSound("People/demogorgon/scream1.mp3") };
                        //person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Assets/People/Batman/flesh.png"));
                        //person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Assets/People/Batman/bone.png"));


                        person.Limbs[10].GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite($"People/demogorgon/upper arm.png");
                        person.Limbs[10].transform.localPosition = new Vector3(0.0158f, -0.2012f, 0);
                        person.Limbs[10].Joint.anchor = new Vector2(-0.013f, 0.17f);
                        person.Limbs[11].GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite($"People/demogorgon/lower arm.png");
                        person.Limbs[11].transform.localPosition = new Vector3(0.0441f, - 0.7883f, 0);
                        person.Limbs[11].Joint.anchor = new Vector2(-0.04f, 0.37f);
                        person.Limbs[12].GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite($"People/demogorgon/upper arm.png");
                        person.Limbs[12].transform.localPosition = new Vector3(0.0158f, -0.2012f, 0);
                        person.Limbs[12].Joint.anchor = new Vector2(-0.013f, 0.17f);
                        person.Limbs[13].GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite($"People/demogorgon/lower arm.png");
                        person.Limbs[13].transform.localPosition = new Vector3(0.0441f, -0.7757f, 0);
                        person.Limbs[13].Joint.anchor = new Vector2(-0.04f, 0.37f);
                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4.5f;
                            body.Health *= 820f;
                            body.InitialHealth *= 80f;
                            body.ShotDamageMultiplier *= 0f;
                            body.BreakingThreshold += 111f;
                            body.Vitality *= 520f;
                            body.ImpactPainMultiplier *= 0.1f;
                            body.Numbness *= 1f;
                            body.CirculationBehaviour.BloodFlow *= 3000f;
                            body.IsLethalToBreak = false;
                            body.transform.root.localScale *= 1.015f;
                            body.GetComponent<LimbBehaviour>().RegenerationSpeed = 9999;
                            body.gameObject.AddComponent<regenstuffnthing>();
                        }
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {

                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Billsogorgon",
                    DescriptionOverride = "roars dramaticaly",
                    CategoryOverride = ModAPI.FindCategory("Stranger Things Power Pack"),
                    ThumbnailOverride = ModAPI.LoadSprite("People/Bilgo/thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("People/bilgo/Demogorgon main.png");
                        var flesh = ModAPI.LoadTexture("People/bonesnflesh/flesh layer.png");
                        var bone = ModAPI.LoadTexture("People/bonesnflesh/bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(skin, flesh, bone, 1);

                        //    person.gameObject.AddComponent<eeee>();

                        person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("People/bilgo/Head.png", 10f);
                        person.Limbs[0].gameObject.AddComponent<DemoScreamer>().NormalHead = ModAPI.LoadSprite("People/bilgo/Head.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<DemoScreamer>().ScreamHead = ModAPI.LoadSprite("People/bilgo/Head bad.png", 10f);
                        person.Limbs[0].gameObject.GetComponent<DemoScreamer>().Wowsounds = new List<AudioClip>() { ModAPI.LoadSound("People/bilgo/scream1.wav"), ModAPI.LoadSound("People/bilgo/scream2.wav"), ModAPI.LoadSound("People/bilgo/scream3.wav") };
                        //person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Assets/People/Batman/flesh.png"));
                        //person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Assets/People/Batman/bone.png"));


                        person.Limbs[10].GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite($"People/bilgo/upper arm.png");
                        person.Limbs[10].transform.localPosition = new Vector3(0.0158f, -0.2012f, 0);
                        person.Limbs[10].Joint.anchor = new Vector2(-0.013f, 0.17f);
                        person.Limbs[11].GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite($"People/bilgo/lower arm.png");
                        person.Limbs[11].transform.localPosition = new Vector3(0.0441f, -0.7883f, 0);
                        person.Limbs[11].Joint.anchor = new Vector2(-0.04f, 0.37f);
                        person.Limbs[12].GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite($"People/bilgo/upper arm.png");
                        person.Limbs[12].transform.localPosition = new Vector3(0.0158f, -0.2012f, 0);
                        person.Limbs[12].Joint.anchor = new Vector2(-0.013f, 0.17f);
                        person.Limbs[13].GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite($"People/bilgo/lower arm.png");
                        person.Limbs[13].transform.localPosition = new Vector3(0.0441f, -0.7757f, 0);
                        person.Limbs[13].Joint.anchor = new Vector2(-0.04f, 0.37f);
                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4.5f;
                            body.Health *= 820f;
                            body.InitialHealth *= 80f;
                            body.ShotDamageMultiplier *= 0f;
                            body.BreakingThreshold += 111f;
                            body.Vitality *= 520f;
                            body.ImpactPainMultiplier *= 0.1f;
                            body.Numbness *= 1f;
                            body.CirculationBehaviour.BloodFlow *= 3000f;
                            body.IsLethalToBreak = false;
                            body.transform.root.localScale *= 1.015f;
                            body.GetComponent<LimbBehaviour>().RegenerationSpeed = 9999;
                            body.gameObject.AddComponent<regenstuffnthing>();
                        }
                    }
                }
            );
        }
    }

    public class pulsate : MonoBehaviour
        {
            public bool dopulse = true;

            public void Start()
            {

            }
            
            public void Update()
            {
                if (dopulse)
                {
                float val = Mathf.Clamp01((Mathf.Sin(Time.time * 1.5f) / 11f) + 0.15f);
                this.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, val);
                }
        }
        }

    public class OtherStuff : MonoBehaviour
    {

        public static void SetBodyPartTexture(LimbBehaviour body, Texture2D Skin, Texture2D Flesh = null)
        {
            float scale = 1f;
            SpriteRenderer renderer = body.SkinMaterialHandler.renderer;
            Sprite sprite1 = renderer.sprite;
            Sprite sprite2 = generateFor(Skin, sprite1);
            renderer.sprite = sprite2;
            if (Flesh)
                renderer.material.SetTexture("_FleshTex", Flesh);



            Sprite generateFor(Texture2D t, Sprite original)
            {
                Texture2D texture = t;
                Rect rect1 = original.rect;
                Vector2 position = rect1.position * scale;
                rect1 = original.rect;
                Vector2 size = rect1.size * scale;
                Rect rect2 = new Rect(position, size);
                Vector2 pivot = new Vector2(0.5f, 0.5f);
                double num = (double)original.pixelsPerUnit * (double)scale;
                Vector4 border = original.border * scale;
                return Sprite.Create(texture, rect2, pivot, (float)num, 0U, SpriteMeshType.FullRect, border, false);

            }
        }

        public static GameObject CreateCanvas(bool AddUiBlocker = true, bool AddGreyBgg = true)
        {
            if (!FindObjectOfType<CanvasTag>())
            {
                if (AddUiBlocker)
                    GameObject.FindObjectOfType<Global>().AddUiBlocker();
                GameObject Canvas = new GameObject();
                GameObject GreyBg;
                if (AddGreyBgg)
                {
                    GreyBg = UiCreatingStuff.CreatePanel(Canvas, new Vector2(55500, 55500), Vector2.zero, 0.7f);
                    GreyBg.GetComponent<Image>().color = new Color(0.2075472f, 0.2075472f, 0.2075472f, 0.5450981f);
                    Canvas.AddComponent<CanvasTag>().Bg = GreyBg;
                }
                Canvas.AddComponent<Canvas>();
                Canvas.AddComponent<CanvasScaler>();
                Canvas.AddComponent<GraphicRaycaster>();
                Canvas.GetComponent<Canvas>().renderMode = RenderMode.ScreenSpaceOverlay;
                Canvas.GetComponent<Canvas>().sortingOrder = -2;
                Canvas.GetComponent<CanvasScaler>().uiScaleMode = CanvasScaler.ScaleMode.ScaleWithScreenSize;
                Canvas.GetComponent<CanvasScaler>().referenceResolution = new Vector2(1920, 1080);
                Canvas.GetComponent<CanvasScaler>().screenMatchMode = CanvasScaler.ScreenMatchMode.MatchWidthOrHeight;
                Canvas.GetComponent<CanvasScaler>().matchWidthOrHeight = 0.763f;
                return Canvas;
            }
            else return null;
        }

        public class CanvasTag : MonoBehaviour
        {
            public GameObject Bg;

            public void OnDestroy()
            {
                if (FindObjectOfType<Global>().ActiveUiBlockers > 0)
                    FindObjectOfType<Global>().RemoveUiBlocker();

                if (Bg)
                    Destroy(Bg);
            }
        }
    }

    public class eeee : MonoBehaviour
    {
        public void Update()
        {
            foreach (var item in FindObjectsOfType<HingeJoint2D>())
            {
                ModAPI.Draw.Circle(item.transform.TransformPoint(item.anchor),0.01f);
            }
        }
    }

    public class DemoScreamer : MonoBehaviour, Messages.IUse
    {
        LimbBehaviour Head;
        public Sprite ScreamHead;
        public Sprite NormalHead;
        private PhysicalProperties prop;
        private PhysicalProperties oldProp;
        bool Screaming = false;
        public List<AudioClip> Wowsounds;
        public AudioSource audio;
        public GameObject SounderObject;
        public void Awake()
        {
            SounderObject = new GameObject();
            SounderObject.transform.SetParent(transform,false);
            Head = GetComponent<LimbBehaviour>();
            audio = SounderObject.AddComponent<AudioSource>();
            audio.spatialBlend = 1;
            audio.volume = 1;
            SounderObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.85f;
            oldProp = Head.PhysicalBehaviour.Properties;
            prop = Instantiate(Head.PhysicalBehaviour.Properties);
            prop.Sharp = true;
            var knife = ModAPI.FindSpawnable("Knife").Prefab.GetComponent<PhysicalBehaviour>().Properties.SharpAxes[0];
            prop.SharpAxes = new SharpAxis[] {
                new SharpAxis(Vector2.right, knife.LowerLimit, knife.UpperLimit, knife.LooseLowerLimit, knife.LooseUpperLimit)
            };
        }


        public void Use(ActivationPropagation activation)
        {
            if (!Screaming && Head.Person.IsAlive())
                StartCoroutine(Scream());
            else if (Head.Person.IsAlive())
                StartCoroutine(ScreamEnd());

        }

        IEnumerator Scream()
        {
            Screaming = true;
            Head.SkinMaterialHandler.renderer.sprite = ScreamHead;
            audio.clip = Wowsounds[UnityEngine.Random.RandomRange(0, 3)];
            audio.Play();
            Head.PhysicalBehaviour.Properties = prop;
            yield return new WaitForSeconds(0.1f);
        }

        private IEnumerator ScreamEnd()
        {
            Head.SkinMaterialHandler.renderer.sprite = NormalHead;
            Head.PhysicalBehaviour.Properties = oldProp;
            if (Head.PhysicalBehaviour.penetrations.Count > 0 && Head.PhysicalBehaviour.penetrations[0].Active && Head.PhysicalBehaviour.penetrations[0].Victim.gameObject.GetComponent<LimbBehaviour>())
            {
                Head.PhysicalBehaviour.penetrations[0].Victim.gameObject.GetComponent<LimbBehaviour>().Crush();
            }
            yield return new WaitForSeconds(0.1f);
            Screaming = false;
        }
    }

    public class UiCreatingStuff : MonoBehaviour
    {
        //I worked so hard on this system, you yoink it and i'll get you - camdog74


        public static GameObject CreatePanel(GameObject ParentOrCanvas, Vector2 SizeDelta, Vector3 Postion, float Opacity = 0.4f)
        {
            //Powers Panel
            GameObject Panel = new GameObject("Panel");
            Panel.AddComponent<CanvasRenderer>();
            Image AppImage = Panel.AddComponent<Image>();
            AppImage.color = new Color(0, 0, 0, Opacity);
            Panel.transform.SetParent(ParentOrCanvas.transform, false);
            Panel.GetComponent<RectTransform>().sizeDelta = SizeDelta;
            Panel.GetComponent<RectTransform>().localPosition = Postion;
            return Panel;
        }


    }

    public class SnapFade : MonoBehaviour
    {
        GameObject Canvas;
        public Image FadeImage;
        bool StartFading = false;
        public float WaitTilFadeTime = 0f;
        public float FadeTime = 1.5f;
        public Color EndColor = Color.black;
        public Color StartColor = Color.clear;
        public void Start()
        {
            Canvas = OtherStuff.CreateCanvas(false, false);
            FadeImage = UiCreatingStuff.CreatePanel(Canvas, Vector2.one * 99999, Vector3.zero, 1).GetComponent<Image>();
            FadeImage.color = StartColor;
            StartCoroutine(Wait());
            //   UiCreatingStuff.
        }
        public void Update()
        {
            if (StartFading)
            {
                FadeImage.color = Color.Lerp(FadeImage.color, EndColor, 7f * Time.deltaTime);
            }
        }

        public void OnDestroy()
        {
            if (Canvas)
                Destroy(Canvas);
        }

        IEnumerator Wait()
        {
            yield return new WaitForSeconds(WaitTilFadeTime);
            StartFading = true;
            yield return new WaitForSeconds(FadeTime);
            StartFading = false;
            gameObject.AddComponent<SnapFade2>().StartColor = EndColor;
            gameObject.GetComponent<SnapFade2>().Canvas = Canvas;
            gameObject.GetComponent<SnapFade2>().FadeImage = FadeImage;
        }
    }
    public class SnapFade2 : MonoBehaviour
    {
        public GameObject Canvas;
        public Image FadeImage;
        bool StartFading = false;
        public float WaitTilFadeTime = 0f;
        public float FadeTime = 1.5f;
        public Color StartColor = Color.black;
        public void Start()
        {
            FadeImage.color = StartColor;
            StartCoroutine(Wait());
            //   UiCreatingStuff.
        }
        public void Update()
        {
            if (StartFading)
            {
                FadeImage.color = Color.Lerp(FadeImage.color, Color.clear, 5f * Time.deltaTime);
            }
        }

        public void OnDestroy()
        {
            if (Canvas)
                Destroy(Canvas);
        }

        IEnumerator Wait()
        {
            yield return new WaitForSeconds(WaitTilFadeTime);
            StartFading = true;
            yield return new WaitForSeconds(FadeTime);
            Destroy(Canvas);
            Destroy(gameObject);
        }
    }

    public class twoptr : MonoBehaviour
    {

    }

    public class AudioLerp : MonoBehaviour
    {
        public AudioSource aud;
        public bool InUpsideDown;

        public void Update()
        {
            aud.volume = Mathf.Lerp(aud.volume, (InUpsideDown)? 1f : 0f, Time.deltaTime / ((InUpsideDown)? 8f : 1.5f));
        }
    }

    public class FixPortalClearStuff : MonoBehaviour
    {
        private void OnDestroy()
        {
            UpsidedownPortal.Enabled = false;
            UpsidedownPortal.lerpy.InUpsideDown = false;
            UpsidedownPortal.DoingAnim = false;
            if (GameObject.Find("snow(Clone)") != null)
            {
                var snoe = GameObject.Find("snow(Clone)");
                snoe.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                snoe.GetComponent<SpriteRenderer>().material.SetVector("_SnowDirection", new Vector4(0f, 1f, 0f, 0f));
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Intensity", 1f);
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Visibility", 0f);
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Density", 1f);
            }
            Destroy(UpsidedownPortal.ScreenLight.gameObject);
            Destroy(UpsidedownPortal.ScreenLight2.gameObject);
            Global.main.CameraControlBehaviour.enabled = true;
            UpsidedownPortal.oldAud = UpsidedownPortal.aud;
            UpsidedownPortal.aud.volume = 0f;
            UpsidedownPortal.aud = null;
            Destroy(UpsidedownPortal.lerpy);
            UpsidedownPortal.Walls = null;
            Global.main.StartCoroutine(thing());
            foreach (var phys in Global.main.PhysicalObjectsInWorld)
            {
                if (phys.transform.root.gameObject.name != "WORLD" && phys.gameObject.layer != 11 && phys.Deletable && phys.gameObject.GetComponent<Undraggable>() == null)
                {
                    Destroy(phys.transform.root.gameObject);
                }
            }
        }

        private IEnumerator thing()
        {
            yield return new WaitForFixedUpdate();
            var snow = MapConfig.Instance.Settings.ShallowClone();
            snow.Snow = false;
            snow.Lightning_chance = 0f;
            snow.Ambient_temperature = 20f;
            MapConfig.Instance.ApplySettings(snow);
        }
    }

    public class UpsidedownPortal : MonoBehaviour
    {
        public static bool Enabled = false;
        public Transform thing = Camera.main.transform;
        public static LightSprite ScreenLight;
        public static LightSprite ScreenLight2;
        public static GameObject phoney1;
        public static GameObject phoney2;
        public static AudioSource aud;
        public static AudioSource oldAud;
        public static AudioLerp lerpy;
        public static bool DoingAnim = false;
        public static Sprite wallvine = ModAPI.LoadSprite("Upside Down/wallvine.png");
        public static Color oldLightningColor = new Color(0.9608f, 0.7765f, 1f, 1f);
        public WeatherLightningBehaviour weath;
        public static Sprite Walls;
        public static float camFov;
        public static float[] SS;

        private List<GameObject> RepeaterStop = new List<GameObject>();

        public void Start()
        {
            if (aud == null)
            {
                if (oldAud != null)
                {
                    aud = oldAud;
                }
                else
                {
                    aud = Camera.main.gameObject.AddComponent<AudioSource>();
                    aud.loop = true;
                    aud.clip = gameObject.GetComponent<AudioSource>().clip;
                    aud.volume = 0f;
                    aud.spatialBlend = 0f;
                    aud.spatialize = false;
                    aud.minDistance = 99999999f;
                    aud.maxDistance = 99999999f;
                    aud.Play();
                    Camera.main.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>().IsAmbience = true;
                }
                var obje = new GameObject();
                obje.AddComponent<FixPortalClearStuff>();
                obje.layer = 9;
                lerpy = Global.main.gameObject.AddComponent<AudioLerp>();
                lerpy.aud = aud;
                SS = new float[]
                {
                    FindObjectOfType<PanelsBehaviour>().gameObject.GetComponent<SpriteRenderer>().material.GetFloat("_PanelSize"),
                    FindObjectOfType<PanelsBehaviour>().gameObject.GetComponent<SpriteRenderer>().material.GetFloat("_Scale")
                };
                foreach (PhysicalBehaviour phys in Global.main.PhysicalObjectsInWorld)
                {
                    if (!RepeaterStop.Contains(phys.transform.root.gameObject) && phys.transform.root.gameObject.name != "WORLD" && phys.transform.root.gameObject.GetComponent<PersonBehaviour>() == null && phys.transform.root != transform.root && phys.gameObject.layer != 11 && phys.Deletable && phys.gameObject.GetComponent<Undraggable>() == null && phys.transform.root.gameObject.GetComponent<ExistOnlyInUpsideDown>() == null)
                    {
                        RepeaterStop.Add(phys.transform.root.gameObject);
                    }
                }
                var objs = ObjectStateConverter.Convert(ObjectStateConverter.Convert(RepeaterStop, Vector3.zero), Vector3.zero); //why
                foreach (var obj in objs)
                {
                    foreach (var phys in obj.GetComponentsInChildren<PhysicalBehaviour>())
                    {
                        phys.SpawnSpawnParticles = false;
                        Global.main.PhysicalObjectsInWorld.Add(phys);
                    }
                    obj.AddComponent<ExistOnlyInUpsideDown>();
                    obj.SetActive(false);
                }
            }

            wallvine.texture.wrapMode = TextureWrapMode.Repeat;


            if (Walls == null)
            {
                Walls = FindObjectOfType<PanelsBehaviour>().gameObject.GetComponent<SpriteRenderer>().sprite;
                backupCheck = new List<PhysicalBehaviour>(Global.main.PhysicalObjectsInWorld);
            }

            if (ScreenLight == null)
            {
                ScreenLight = ModAPI.CreateLight(Global.main.transform, new Color(0.3f, 0.3f, 0.25f, 1f));
                ScreenLight2 = ModAPI.CreateLight(Global.main.transform, new Color(1f, 1f, 1f, 1f));
                ScreenLight.Brightness = 0f;
                ScreenLight.Radius = 9999999f;
                ScreenLight2.Brightness = 0f;
                ScreenLight2.Radius = 9999999f;
                Global.main.StartCoroutine(LoopCheck());
            }

            weath = FindObjectOfType<WeatherLightningBehaviour>();
            var thingy = new ContextMenuButton("RegenerateUpsideDown", "Regenerate Upside Down", "Reloads the Upside Down", new UnityAction[] { new UnityAction(RegenerateUpsideDown) });
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(thingy);
        }

        private List<GameObject> deleteQueue = new List<GameObject>();

        public void RegenerateUpsideDown()
        {
            if (Enabled)
            {
                ModAPI.Notify("Can't regenerate the portal in the Upside Down.");
                return;
            }
            RepeaterStop.Clear();
            foreach (PhysicalBehaviour phys in Global.main.PhysicalObjectsInWorld)
            {
                if (phys.transform.root.gameObject.GetComponent<ExistOnlyInUpsideDown>() != null && phys.gameObject.GetComponent<UpsidedownPortal>() == null && !deleteQueue.Contains(phys.transform.root.gameObject))
                {
                    deleteQueue.Add(phys.transform.root.gameObject);
                    continue;
                }
                if (!RepeaterStop.Contains(phys.transform.root.gameObject) && phys.transform.root.gameObject.name != "WORLD" && phys.transform.root.gameObject.GetComponent<PersonBehaviour>() == null && phys.transform.root != transform.root && phys.gameObject.layer != 11 && phys.Deletable && phys.gameObject.GetComponent<Undraggable>() == null && phys.gameObject.GetComponent<UpsidedownPortal>() == null && phys.transform.root.gameObject.GetComponent<ExistOnlyInUpsideDown>() == null)
                {
                    RepeaterStop.Add(phys.transform.root.gameObject);
                }
            }
            foreach (var deleteme in deleteQueue)
            {
                Destroy(deleteme);
            }
            deleteQueue.Clear();
            var objs = ObjectStateConverter.Convert(ObjectStateConverter.Convert(RepeaterStop, Vector3.zero), Vector3.zero); //why
            foreach (var obj in objs)
            {
                foreach (var phys in obj.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    phys.SpawnSpawnParticles = false;
                    Global.main.PhysicalObjectsInWorld.Add(phys);
                }
                obj.AddComponent<ExistOnlyInUpsideDown>();
                obj.SetActive(false);
            }
        }

        public void OnCollisionEnter2D(Collision2D col)
        {
            if (col.transform.root.gameObject.GetComponent<PortalTraveller>() == null && col.transform.root.gameObject.GetComponent<PersonBehaviour>() != null)
            {
                if (Enabled & col.transform.root.gameObject.GetComponent<ExistOnlyInUpsideDown>() != null)
                {
                    Destroy(col.transform.root.gameObject.GetComponent<ExistOnlyInUpsideDown>());
                }
                if (!Enabled & col.transform.root.gameObject.GetComponent<ExistOnlyInUpsideDown>() == null)
                {
                    col.transform.root.gameObject.AddComponent<ExistOnlyInUpsideDown>();
                }
                col.transform.root.gameObject.SetActive(false);
                col.transform.root.gameObject.AddComponent<PortalTraveller>(); //reused component
            }
        }

        public void Use()
        {
            if (DoingAnim)
            {
                return;
            }
            if (!Enabled)
            {
                Global.main.StartCoroutine(UpsideDownEnter());
            }
            else
            {
                Global.main.StartCoroutine(UpsideDownExit());
            }
        }

        public void Update()
        {
            if (DoingAnim)
            {
                this.gameObject.GetOrAddComponent<twoptr>();
            }
        }

        private static List<PhysicalBehaviour> backupCheck = new List<PhysicalBehaviour>();

        public IEnumerator LoopCheck() //hope this works
        {
            while (true)
            {
                Global.main.PhysicalObjectsInWorld.RemoveAll(x => x == null);
                if (Enabled && backupCheck.Count != Global.main.PhysicalObjectsInWorld.Count)
                {
                    foreach (var phys in Global.main.PhysicalObjectsInWorld)
                    {
                        if (!backupCheck.Contains(phys) && phys.transform.root.gameObject.name != "WORLD" && phys.transform.root.gameObject.activeInHierarchy && phys.transform.root.gameObject.GetComponent<ExistOnlyInUpsideDown>() == null)
                        {
                            phys.transform.root.gameObject.GetOrAddComponent<ExistOnlyInUpsideDown>();
                        }
                    }
                    backupCheck = new List<PhysicalBehaviour>(Global.main.PhysicalObjectsInWorld);
                }
                yield return new WaitForEndOfFrame();
            }
        }

        private IEnumerator ZoomCam(float result, float time)
        {
            float i = 0f;
            while (!Mathf.Approximately(Global.main.camera.orthographicSize, result) && i < time)
            {
                Global.main.camera.orthographicSize = Mathf.Lerp(Global.main.camera.orthographicSize, result, Time.deltaTime * 1.5f);
                i += Time.deltaTime;
                yield return new WaitForEndOfFrame();
            }
            yield return new WaitForEndOfFrame();
        }

        private IEnumerator UpsideDownEnter()
        {
            new GameObject().AddComponent<SnapFade>().EndColor = Color.black;
            var mover = Instantiate(ModAPI.FindSpawnable("Brick").Prefab, transform.position, Quaternion.identity); //hacky method to move camera
            mover.SetActive(false);
            Global.main.CameraControlBehaviour.CurrentlyFollowing.Clear();
            Global.main.CameraControlBehaviour.CurrentlyFollowing.Add(mover.GetComponent<PhysicalBehaviour>());
            camFov = Global.main.camera.orthographicSize;
            yield return new WaitForSeconds(0.05f);
            Global.main.CameraControlBehaviour.enabled = false;
            Global.main.StartCoroutine(ZoomCam(0.01f, 1.5f));
            DoingAnim = true;
            yield return new WaitForSeconds(1.5f);
            Global.main.StartCoroutine(ZoomCam(camFov, 3f));
            ScreenLight.Brightness = -30f;
            ScreenLight2.Brightness = 1.5f;
            foreach (var item in GameObject.FindObjectsOfType<PanelsBehaviour>())
            {
                item.gameObject.GetComponent<SpriteRenderer>().sprite = wallvine;
                item.gameObject.GetComponent<SpriteRenderer>().material.SetFloat("_PanelSize", 769f); //768f now
                item.gameObject.GetComponent<SpriteRenderer>().material.SetFloat("_Scale", 0.166666666666f); //divide by 2
            }
            RepeaterStop.Clear();
            foreach (var phys in Global.main.PhysicalObjectsInWorld)
            {
                if (!RepeaterStop.Contains(phys.transform.root.gameObject) && phys.transform.root.gameObject.name != "WORLD" && phys.gameObject.GetComponent<UpsidedownPortal>() == null && phys.transform.root != transform.root && phys.gameObject.layer != 11 && phys.Deletable && phys.gameObject.GetComponent<Undraggable>() == null)
                {
                    if (phys.transform.root.gameObject.TryGetComponent<ExistOnlyInUpsideDown>(out var bruh))
                    {
                        phys.transform.root.gameObject.SetActive(true);
                        var cols = phys.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                        foreach (var col1 in cols)
                        {
                            foreach (var col2 in cols)
                            {
                                Physics2D.IgnoreCollision(col1, col2);
                            }
                        }
                        if (phys.gameObject.GetComponent<WireBehaviour>() != null)
                        {
                            phys.gameObject.AddComponent<JointFixer>();
                        }
                    }
                    else
                    {
                        phys.transform.root.gameObject.SetActive(false);
                    }
                    RepeaterStop.Add(phys.transform.root.gameObject);
                }
            }
            foreach (var item in GameObject.FindObjectsOfType<AudioSource>())
            {
                if (item.gameObject.name.Contains("Hum"))
                {
                    item.gameObject.GetComponent<AudioSource>().volume = 0f;
                }
            }
            if (MapConfig.Instance.gameObject.transform.Find("LightningWeather(Clone)") != null)
            {
                MapConfig.Instance.gameObject.transform.Find("LightningWeather(Clone)").gameObject.GetComponent<AudioSource>().volume = 0f;
            }

            if (weath != null)
            {
                weath.LineRenderer.startColor = Color.red;
                weath.LineRenderer.endColor = Color.red;
                weath.LightSprite.color = Color.red;
                weath.LightSprite.material.SetFloat("_GlowIntensity", weath.LightSprite.material.GetFloat("_GlowIntensity") * 2f);
                phoney1 = Instantiate(weath.LightSprite.gameObject, weath.transform);
                phoney2 = Instantiate(weath.LightSprite.gameObject, weath.transform);
            }

            var snow = MapConfig.Instance.Settings.ShallowClone();
            snow.Snow = true;
            snow.Lightning_chance = 45f;
            snow.Ambient_temperature = 8f;
            MapConfig.Instance.ApplySettings(snow);
            lerpy.InUpsideDown = true;
            yield return new WaitForSeconds(0.1f);
            if (GameObject.Find("snow(Clone)") != null)
            {
                var snoe = GameObject.Find("snow(Clone)");
                snoe.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                snoe.GetComponent<SpriteRenderer>().material.SetVector("_SnowDirection", new Vector4(0.35f, 0f, 0f, 0f));
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Intensity", 2f);
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Visibility", 2.5f);
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Density", 0.75f);
            }
            yield return new WaitForSeconds(2.9f);
            Global.main.CameraControlBehaviour.enabled = true;
            Global.main.CameraControlBehaviour.CurrentlyFollowing.Clear();
            Destroy(mover);
            Enabled = true;
            DoingAnim = false;
            yield return new WaitForEndOfFrame();
        }

        private IEnumerator UpsideDownExit()
        {
            new GameObject().AddComponent<SnapFade>().EndColor = Color.black;
            var mover = Instantiate(ModAPI.FindSpawnable("Brick").Prefab, transform.position, Quaternion.identity); //hacky method to move camera
            mover.SetActive(false);
            Global.main.CameraControlBehaviour.CurrentlyFollowing.Clear();
            Global.main.CameraControlBehaviour.CurrentlyFollowing.Add(mover.GetComponent<PhysicalBehaviour>());
            camFov = Global.main.camera.orthographicSize;
            yield return new WaitForSeconds(0.05f);
            Global.main.CameraControlBehaviour.enabled = false;
            Global.main.StartCoroutine(ZoomCam(0.01f, 1.5f));
            DoingAnim = true;
            yield return new WaitForSeconds(1.5f);
            Global.main.StartCoroutine(ZoomCam(camFov, 3f));
            ScreenLight.Brightness = 0f;
            ScreenLight2.Brightness = 0f;
            foreach (var item in GameObject.FindObjectsOfType<PanelsBehaviour>())
            {
                item.gameObject.GetComponent<SpriteRenderer>().sprite = Walls;
                item.gameObject.GetComponent<SpriteRenderer>().material.SetFloat("_PanelSize", SS[0]);
                item.gameObject.GetComponent<SpriteRenderer>().material.SetFloat("_Scale", SS[1]);
            }
            RepeaterStop.Clear();

            foreach (var phys in Global.main.PhysicalObjectsInWorld)
            {
                if (!RepeaterStop.Contains(phys.transform.root.gameObject) && phys.gameObject.GetComponent<UpsidedownPortal>() == null && phys.transform.root.gameObject.name != "WORLD" && phys.transform.root != transform.root && phys.gameObject.layer != 11 && phys.Deletable && phys.gameObject.GetComponent<Undraggable>() == null)
                {
                    if (phys.transform.root.gameObject.TryGetComponent<ExistOnlyInUpsideDown>(out var bruh))
                    {
                        phys.transform.root.gameObject.SetActive(false);
                    }
                    else
                    {
                        phys.transform.root.gameObject.SetActive(true);
                        var cols = phys.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                        foreach (var col1 in cols)
                        {
                            foreach (var col2 in cols)
                            {
                                Physics2D.IgnoreCollision(col1, col2);
                            }
                        }
                        if (phys.gameObject.GetComponent<WireBehaviour>() != null)
                        {
                            phys.gameObject.AddComponent<JointFixer>();
                        }
                    }
                    RepeaterStop.Add(phys.transform.root.gameObject);
                }
            }
            foreach (var item in GameObject.FindObjectsOfType<AudioSource>())
            {
                if (item.gameObject.name.Contains("Hum"))
                {
                    item.gameObject.GetComponent<AudioSource>().volume = 0f;
                }
            }
            if (MapConfig.Instance.gameObject.transform.Find("LightningWeather(Clone)") != null)
            {
                MapConfig.Instance.gameObject.transform.Find("LightningWeather(Clone)").gameObject.GetComponent<AudioSource>().volume = 0f;
            }
            if (weath != null)
            {
                weath.LineRenderer.startColor = UpsidedownPortal.oldLightningColor;
                weath.LineRenderer.endColor = UpsidedownPortal.oldLightningColor;
                weath.LightSprite.material.SetFloat("_GlowIntensity", weath.LightSprite.material.GetFloat("_GlowIntensity") / 2f);
                Destroy(phoney1);
                Destroy(phoney2);
            }
            
            if (GameObject.Find("snow(Clone)") != null)
            {
                var snoe = GameObject.Find("snow(Clone)");
                snoe.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                snoe.GetComponent<SpriteRenderer>().material.SetVector("_SnowDirection", new Vector4(0f, 1f, 0f, 0f));
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Intensity", 1f);
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Visibility", 0f);
                snoe.GetComponent<SpriteRenderer>().material.SetFloat("_Density", 1f);
            }
            
            var snow = MapConfig.Instance.Settings.ShallowClone();
            snow.Snow = false;
            snow.Lightning_chance = 0f;
            snow.Ambient_temperature = 20f;
            MapConfig.Instance.ApplySettings(snow);
            lerpy.InUpsideDown = false;
            yield return new WaitForSeconds(3f);
            Global.main.CameraControlBehaviour.enabled = true;
            Global.main.CameraControlBehaviour.CurrentlyFollowing.Clear();
            Destroy(mover);
            Enabled = false;
            DoingAnim = false;
            yield return new WaitForEndOfFrame();
        }

    }
}

public class JointFixer : MonoBehaviour
{
    private void Start()
    {
        StartCoroutine(fix());
    }

    private IEnumerator fix()
    {
        foreach (var joint in gameObject.GetComponentsInChildren<Joint2D>())
        {
            joint.enabled = false;
        }
        foreach (var joint in gameObject.GetComponentsInChildren<Joint2D>())
        {
            joint.enabled = true;
        }
        yield return new WaitForEndOfFrame();
        Destroy(this);
    }
}

public class RepeatStopper : MonoBehaviour
{
    private void Start()
    {
        Destroy(this);
    }
}

public class RogVoice : MonoBehaviour
{
    public AudioClip PantsFeetSong = ModAPI.LoadSound("People/Wilson/EKSE.wav");
    //   public AudioClip AvengersSong = ModAPI.LoadSound("Wilson Evolved.wav");
    public AudioClip Pain = ModAPI.LoadSound("People/Wilson/Rogpain.wav");
    public AudioClip Dead = ModAPI.LoadSound("People/Wilson/RogKill.wav");
    public AudioClip sleepp = ModAPI.LoadSound("People/Wilson/RogKill.wav");
    public AudioSource audio;
    List<GameObject> Hands = new List<GameObject>();
    bool SetDead = false;
    bool Sleep = false;
    bool Sword = false;
    public void Start()
    {
        GameObject AUdio = new GameObject();
        AUdio.transform.SetParent(transform, false);
        audio = AUdio.gameObject.AddComponent<AudioSource>();
        audio.spatialBlend = 1;
        AUdio.AddComponent<AudioDistortionFilter>().distortionLevel = 0.8f;
        item = GetComponent<LimbBehaviour>();
        foreach (var item in transform.parent.GetComponentsInChildren<GripBehaviour>())
        {
            Hands.Add(item.gameObject);
        }
    }

    public LimbBehaviour item;
    public void Update()
    {
        if (item.IsConsideredAlive && item.Person.Consciousness > 0.8f)
        {
            Sleep = false;
            SetDead = false;
            if (!(item.Person.ShockLevel > 0) && ((!Sword && audio.clip != PantsFeetSong)))
            {
                if (!Sword)
                    audio.clip = PantsFeetSong;
                //     else audio.clip = AvengersSong;
                audio.loop = true;
                audio.Play();
            }
            else
            {
                if ((item.Person.ShockLevel > 0) && audio.clip != Pain)
                {
                    audio.clip = Pain;
                    audio.loop = true;
                    audio.Play();
                }
            }
        }
        else if (item.Person.Consciousness < 0.8f && !Sleep)
        {
            audio.Stop();
            Sleep = true;
            audio.clip = sleepp;
            audio.loop = false;
            audio.Play();
        }
        else if (!item.IsConsideredAlive && !SetDead)
        {
            SetDead = true;
            audio.clip = Dead;
            audio.loop = false;
            audio.Play();
        }


        //if ((Hands[0].GetComponent<GripBehaviour>().CurrentlyHolding && Hands[0].GetComponent<GripBehaviour>().CurrentlyHolding.name == "The Almighty Sword") || (Hands[1].GetComponent<GripBehaviour>().CurrentlyHolding && Hands[1].GetComponent<GripBehaviour>().CurrentlyHolding.name == "The Almighty Sword"))
        //    Sword = true;
        //else Sword = false;


    }


}
public class CustomBodyPart : MonoBehaviour
    {
        //This is for people with sprites that go out of the games sprite boundarys.

        public Sprite OgSkin;
        public Texture2D OgFlesh;
        public Texture2D OgBone;

        public Sprite NewSkin;
        public Texture2D NewFlesh;
        public Texture2D NewBone;

        //This sets the sprite back to the orignal skin that isn't custom, we use this for stuff
        //like the iron man suit and venom, so we can change to those skins.
        public void SetOriginalTextures()
        {
            this.GetComponent<SpriteRenderer>().sprite = OgSkin;
            this.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", OgFlesh);
            this.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", OgBone);
        }

        //This sets the body part to the new sprite
        public void SetNewTextures()
        {
            this.GetComponent<SpriteRenderer>().sprite = NewSkin;
            this.GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", NewFlesh);
            this.GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", NewBone);
        }
    }
public class DontDoVines : MonoBehaviour
{
}
public class ExistOnlyInUpsideDown : MonoBehaviour
{

}
public class PortalTraveller : MonoBehaviour
{
    public void Start()
    {
        StartCoroutine(wait());
    }

    private IEnumerator wait()
    {
        yield return new WaitForSeconds(5f);
        Destroy(this);
    }
}
public class dfd : MonoBehaviour
{
    public GameObject guh;

    public void Update()
    {
        this.transform.position = guh.transform.position;
        this.transform.rotation = guh.transform.rotation;
    }
}

public class regenstuffnthing : MonoBehaviour
{
    public LimbBehaviour limb;
    public bool CanRegen = true;
    public bool CanResurect = false;
    public bool CanBeKnockedOut = true;
    public float RegenSpeed = 2;
    public bool LimbDieOnDismembered = true;

    public void Start()
    {
        limb = GetComponent<LimbBehaviour>();
        StartCoroutine(BaseHeal(limb));
    }

    Coroutine coroutine1;
    Coroutine coroutine2;
    Coroutine coroutine3;
    Coroutine coroutine4;
    Coroutine coroutine5;

    private IEnumerator BaseHeal(LimbBehaviour limb)
    {

        if (CanResurect || (!CanResurect && limb.IsConsideredAlive))
        {
            while (CanRegen == true && ((LimbDieOnDismembered && !limb.IsDismembered) || !LimbDieOnDismembered))
            {
                if (limb.PhysicalBehaviour.OnFire)
                {
                    limb.CirculationBehaviour.RemoveLiquid(Liquid.GetLiquid("DEMOHEAL"), 10f);
                    yield return new WaitForSeconds(0.8f);
                    yield break;
                }
                limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("DEMOHEAL"), 1f);
                yield return new WaitForSeconds(0.8f);
            }
        }
    }
}

public class DemoHeal : LifeSyringe.LifeSerumLiquid
{
    public DemoHeal()
    {
        this.Color = Liquid.GetLiquid("BLOOD").Color;
    }
}